; NEU 20060401
;*********************************************************************
; HektarLayer einbau Var:
; ADR_HMAP_HEKT_KR_Layer        ... "k-p"
(setq ADR_HMAP_HEKT_KR_Layer "k-p")
; ADR_HMAP_HEKT_SCHR_Layer      ... "k-s"
(setq ADR_HMAP_HEKT_SCHR_Layer "k-s")
;blocknamen
; ADR_HMAP_HEKT_KR_Blockname    ... GDS5
(setq ADR_HMAP_HEKT_KR_Blockname "GDS5")
; ADR_HMAP_HEKT_SCHR_Blockname  ...
(setq ADR_HMAP_HEKT_SCHR_Blockname "GDS6")

(vl-doc-export 'ADR_HMAP_Setup_HEKT)
(defun ADR_HMAP_Setup_HEKT ( KR_Layer SCHR_Layer KR_Blockname SCHR_Blockname / )
  (setq ADR_HMAP_HEKT_KR_Layer KR_Layer)
  (setq ADR_HMAP_HEKT_SCHR_Layer SCHR_Layer)
  (setq ADR_HMAP_HEKT_KR_Blockname KR_Blockname)
  (setq ADR_HMAP_HEKT_SCHR_Blockname SCHR_Blockname)
)


;Hektarnetz
(defun heksin (mfak / ip )
  (while (setq ip (getpoint "Einsetzpunkt"))
      ;(command "_insert" (strcat adr_symbol_path "gds5") "_none" ip mfak "" "")
       (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_KR_Blockname) "_none" ip mfak "" "")
    )
  (setq ip nil)
)

;UEBER FENSTER
(defun ADR_hekwin ( mfak / p1 p2 p1T p2T)
  (princ "Hektarnetz ueber Fenster waehlen:")
  (print)
  (setq p1T (getpoint "linker unterer Randpunkt:")
        p2T (getpoint "rechter oberer Randpunkt:"))
  (setq p1 (list (min (car p2T)(car p1T)) (min(cadr p1T)(cadr p2T))))
  (setq p2 (list (max (car p2T)(car p1T)) (max(cadr p1T)(cadr p2T))))
  ;(setq p2 (list (car p1T) (cadr p2T)))	
  
  (setvar "cmdecho" 1)
  (setvar "Snapang" 0) ;weils davor fr eingabe verndert wird !
  (if (and p1 p2) 
      ;(command "_insert" (strcat adr_symbol_path "gds5") "_None" p1 mfak "" ""
      (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_KR_Blockname) "_None" p1 mfak "" ""
	       "_array" (ssadd (entlast)) "" "_r"
                         (fix (+ 1.01 (/ (abs (- (cadr p2) (cadr p1))) abst)))
 	                 (fix (+ 1.01 (/ (abs (- (car p2) (car p1))) abst)))
			 (abs abst)
			 (abs abst)
      )
  )
  (setq p1 nil p2 nil)
)

;HAUPTPROGRAMM mit SETZEN DER BESCHRIFTUNG
(defun C:HEKTAR ( / a ip y x mfak osmode angbase snapmode)
  (adr_cmdbegin )
  (setq *error* 'Hmap_Hektar_Fehler)
;  (setq snapmode (getvar "snapmode"))
  (setvar "snapmode" 0)
;  (setq osmode (getvar "osmode"))
;  (setq angbase (getvar "angbase"))
  (setvar "angbase" 0)
  (setvar "osmode" 0)
  (setvar "Snapang" 0)
  (setvar "angdir" 0)
  (adr_setlayer ADR_HMAP_HEKT_KR_Layer)
    ;(adr_setlayer "k-p") alt vor 20060401
  ; !!! massstab aus allgemeinen Daten bernehmen
  (setq mfak (/ (scale) 1000))
  (setq abst (getreal "Abstand (in m <100>):"))
  (if (not abst) (setq abst 100))
  (command "_snap" abst "_snap" "_r" "0,0" (angtos (/ PI 2) (getvar "Aunits") 10))
  (setq a (getstring "Marken einzeln einsetzen ? <n> "))
  (if (or (= a "j") (= a "J") ) (heksin mfak ) (ADR_hekwin mfak ))
  (adr_setlayer ADR_HMAP_HEKT_SCHR_Layer)
  ;(adr_setlayer "k-s")
  (while (setq ip (getpoint "Wohin Beschriftung ?"))
         (setq y (strcat "y = " (rtos (car ip) 2 2))
               x (strcat "x = " (rtos (cadr ip) 2 2))
         )  
         (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_SCHR_Blockname) "_none" ip mfak "" (atof(angtos 0)) x y)
  )
;  (setvar "osmode" osmode)
;  (setvar "snapmode" snapmode)
;  (setvar "angbase" angbase)

  (setq *error* nil)
  (adr_cmdende "HMap - Hektarnetz" nil)
)

(defun Hmap_Hektar_Fehler ( msg / )
  (adr_cmdende "Fehler in HMap - Hektarnetz" nil)
  ;(print "ende mit fehler")
)

(defun c:hektarbeschr (/ mfak x y ip )
  ;!!!layer setzen laut datenbank
  (adr_cmdbegin )
  (setq *error* 'Hmap_Hektar_Fehler)
;; (setq snapmode (getvar "snapmode"))
  ;(setvar "snapmode" 0)
 ; (setq osmode (getvar "osmode"))
;  (setq angbase (getvar "angbase"))
  
  ;(setvar "osmode" 0)
  (setvar "angbase" 0)
  (adr_setlayer ADR_HMAP_HEKT_SCHR_Layer)
  (setvar "Snapang" 0)
  (setvar "angdir" 0)
  (setq mfak (/ (scale) 1000))
  ;(setvar "snapmode" 0)
  (while (setq ip (getpoint "Wohin Beschriftung ?"))
    (setq y (strcat "y = " (rtos (car ip) 2 2))
          x (strcat "x = " (rtos (cadr ip) 2 2))
    )  
    (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_SCHR_Blockname) "_none" ip mfak "" (atof(angtos 0)) x y)
  )
;  (setvar "osmode" osmode)
;  (setvar "snapmode" snapmode)
;  (setvar "angbase" angbase)  
  ;!!! layer zurcksetzen
  (setq *error* nil)
  (adr_cmdende "HMap - Hektarnetz" nil)
)  
(defun c:attmove (/)
;  (ADR_CMDBEGIN)
  (while (and
           (setq obj (nentsel "\nAttribut whlen (Enter=Ende):"))
           (setq ent1 (entget (car obj)))
         )
    (if (= "ATTRIB" (cdr (assoc '0 ent1)))
    (progn
      
      ;hier nachsehen ob es ein attribut ist und wenn den blockhighlighten
      (if (assoc '330 ent1) (redraw (cdr (assoc '330 ent1)) 3))
      (setq ent ent1)

      (setq P10 (and (= 0 (cdr (assoc '72 ent)))
                   (= 0 (cdr (assoc '74 ent)))
                )
      )
      (if P10
;;;        (setq PU (cdr (assoc '10 ent)))
;;;        (setq PU (cdr (assoc '11 ent)))
        (setq PU (trans (cdr (assoc '10 ent)) 0 1));nderung um auch mit verdrehtem BKS arbeiten zu knnen !!!
        (setq PU (trans (cdr (assoc '11 ent)) 0 1))
      )
      (setq erg (grread T 15 0))
      (setq PA (cadr erg))
                                        ;(if (not (> (distance (list 0 0 0) (setq PU (cdr (assoc '11 ent)))) 0)) (setq PU (cdr (assoc '10 ent))))
      (setq ende nil)
      (while (not ende)
        (setq ent ent1)
        (setq erg (grread T 15 0))
                                        ;(print erg)
        (setq ende (/= 5 (car erg)))
        (if (not ende)
          (progn
            (setq P10 (and (= 0 (cdr (assoc '72 ent)))
                           (= 0 (cdr (assoc '74 ent)))
                      )
            )
            (if P10
              (setq PN (cdr (assoc '10 ent)))
              (setq PN (cdr (assoc '11 ent)))
            )
            (setq PD (mapcar '- PA (cadr erg)))
            (setq PN1 (Mapcar '- PU PD))
                                        ;(print (list P10 PU PN d a dw wneu refw (+ a dw) pn1))
            
            (if P10
              ;(setq ent (subst (cons 10 PN1) (assoc '10 ent) ent))
              ;(setq ent (subst (cons 11 PN1) (assoc '11 ent) ent))
              (setq ent (subst (cons 10 (trans PN1 1 0)) (assoc '10 ent) ent));nderung um auch mit verdrehtem BKS arbeiten zu knnen !!!
              (setq ent (subst (cons 11 (trans PN1 1 0)) (assoc '11 ent) ent))
            )
            (entmod ent)
            (entupd (cdr (assoc '-1 ent)))
            (if (assoc '330 ent1) (redraw (cdr (assoc '330 ent1)) 3))
            
            
          ) ;_progn
        ) ;_not ende  
      )
      (if (assoc '330 ent1) (entupd (cdr (assoc '330 ent1))))
    );progn  
    );if (wenns ein attribut ist 
  );while
  ;(ADR_CMDENDE "ATTmove" nil)
)
